' FastView2K.VBS V1.05 (C) yoshioka.teruo@nifty.com 2006-03-28
' FastView2K.VBS shows folder to right window and file content to left window.
' Usage: Start FastView2K.VBS folder

Option Explicit

Dim fso
Dim Folder
Dim sfv
Dim ix
Dim ie
Dim txt
Dim img
Dim src,path
Dim ixOnQuit
Dim ieOnQuit
Dim widthMargin,heightMargin
Dim screenWidth,screenHeight

Const txtWidth=400
Const txtHeight=400

Set fso=CreateObject("Scripting.FileSystemObject")

If WScript.Arguments.Count Then
  Folder=WScript.Arguments(0)
Else
  Folder=""
'  Folder="shell:RecycleBinFolder"
'  Folder="shell:DesktopFolder"
End If

If InStr(LCase(Folder),"shell:")=1 Then
ElseIf Left(Folder,2)="::" Then
Else
  Folder=fso.GetAbsolutePathName(Folder)
End If

Set sfv=CreateObject("Shell.FolderView")
'Set sfv=CreateObject("Shell.FolderView.1")
Call WScript.ConnectObject(sfv,"SFV_")

Set ie=WScript.CreateObject("InternetExplorer.Application","IE_")
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Top=0
ie.Left=0
ie.AddressBar=False
ie.MenuBar=False
ie.StatusBar=False
ie.ToolBar=False
'ie.Resizable=False
ie.Document.body.scroll="no"
ie.Document.body.leftMargin=0
ie.Document.body.topMargin=0
ie.Document.body.rightMargin=0
ie.Document.body.bottomMargin=0
widthMargin=ie.Width-ie.Document.body.clientWidth
heightMargin=ie.Height-ie.Document.body.clientHeight
screenWidth=ie.Document.parentwindow.screen.availWidth
screenHeight=ie.Document.parentwindow.screen.availHeight
'WScript.Echo widthMargin,heightMargin,screenWidth,screenHeight
ie.Width=0
ie.Height=0
ie.Visible=True

Set txt=ie.Document.CreateElement("textarea")
Call ie.Document.body.insertadjacentelement("AfterBegin",txt)
'txt.cols=100
'txt.rows=100
txt.style.position="absolute"
txt.style.top=0
txt.style.left=0
txt.style.height="100%"
txt.style.width="100%"
txt.style.display="none"

Set img=ie.Document.CreateElement("img")
Call ie.Document.body.insertadjacentelement("AfterBegin",img)
Set img.onload=GetRef("ViewPad")

Set ix=WScript.CreateObject("InternetExplorer.Application","IX_")
'ix.Top=0
ix.Left=screenWidth/2
ix.Width=screenWidth/2
'ix.Height=0
ix.Navigate Folder
ix.ShowBrowserBar "{EFA24E64-B078-11D0-89E4-00C04FC9E26E}",True
ix.Visible=True

Do While Not ieOnQuit And Not ixOnQuit
  WScript.Sleep 1000
Loop
On Error Resume Next
If Not ieOnQuit Then ie.Quit
If Not ixOnQuit Then ix.Quit
WScript.Quit

Sub ViewPad()
Dim imgWidth,imgHeight
Dim wx,hx
Call img.removeAttribute("Width",0)
Call img.removeAttribute("Height",0)
ie.Document.Title=src
'WScript.Echo img.Width,screenWidth,img.Height,screenHeight
imgWidth=img.Width
imgHeight=img.Height
wx=(screenWidth-widthMargin)/imgWidth 
hx=(screenHeight-heightMargin)/imgHeight 
If wx>hx Then wx=hx
If wx>=1 Then
  ie.Width=imgWidth+widthMargin
  ie.Height=imgHeight+heightMargin
Else
  imgWidth=imgWidth*wx
  imgHeight=imgHeight*wx
  img.Width=imgWidth
  img.Height=imgHeight
  ie.Width=imgWidth+widthMargin
  ie.Height=imgHeight+heightMargin
End If
End Sub

Sub IE_OnQuit()
ieOnQuit=True
End Sub

Sub SFV_SelectionChanged()
Dim BOM
Dim fUNICODE
'WScript.Echo "SelectionChanged",ix.Document.focuseditem
On Error Resume Next
path=ix.Document.FocusedItem.Path
On Error GoTo 0
If path<>src Then
  src=path
  If fso.FileExists(path) Then
    Select Case LCase(fso.GetExtensionName(path))
    Case "bmp","emf","gif","jpg","jpeg","jpe","png","wmf","xbm"
      txt.style.display="none"
      img.src=src
    Case "mpg","mpeg","zip"
      ie.Width=0
      ie.Height=0
    Case Else
      On Error Resume Next
      BOM=fso.OpenTextFile(src).Read(2)
      fUNICODE=BOM=Chr(&HFF)&Chr(&HFE) Or BOM=Chr(&HFE)&Chr(&HFF)
      txt.value=Replace(fso.OpenTextFile(path,,,fUNICODE).Read(1024*32),vbNullChar,"")
      If Err<>0 Then
        txt.value=Err.Number&vbCrLf&Err.Description&vbCrLf&path
      End If
      On Error GoTo 0
      txt.style.display="block"
      If ie.Width<txtWidth Then ie.Width=txtWidth
      If ie.Height<txtHeight Then ie.Height=txtHeight
    End Select
  Else
    ie.Width=0
    ie.Height=0
  End If
End If
End Sub

Sub SFV_EnumDone()
'WScript.Echo "EnumDone"
ix.Visible=True
CreateObject("WScript.Shell").SendKeys "%(vd)"
End Sub

Sub IX_DocumentComplete(pdisp,url)
'WScript.Echo "DocumentComplete",url
sfv.SetFolderView(ix.document)
End Sub

Sub IX_OnQuit()
'WScript.Echo "OnQuit"
ixOnQuit=True
End Sub
